//+----------------------------------------------------------------------------+
//|                                                              stSender.mq4  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |


     
//+----------------------------------------------------------------------------+
#property copyright "http://www.kimiv.ru"
#property link      "http://www.kimiv.ru"

//-------    -----------------------------------------+
extern string _P_Expert = "----------   v.0.7";
extern int    Language       = 1;      // : 0-English, 1-
extern int    NumberAccount  = 0;      //   
extern string stFileName     = "stDeals.csv";
extern bool   PrintEnable    = True;   //    
extern double IntUpdate      = 0;      //     (0- )
extern int    OpenDuringTime = 75;     //      
                                       //  (0 - )

//-------    -------------------------------------+
string msg[6][2];


//+----------------------------------------------------------------------------+
//|  expert initialization function                                            |
//+----------------------------------------------------------------------------+
void init() {
  msg[0][0]="Adviser will is started by next teak";
  msg[0][1]="    ";
  msg[1][0]="Button is not pressed \"Enable experts for running\"";
  msg[1][1]="  \"  \"";
  msg[2][0]="IMPOSSIBLE work with account "+AccountNumber();
  msg[2][1]="    "+AccountNumber();
  msg[3][0]="IS ABSENT relationship with trade server\n"+
            "Transmission of trade commands is STOPPED";
  msg[3][1]="    \n"+
            "   ";
  msg[4][0]="Button is not pressed \"Enable experts for running\"\n"+
            "Expert Adviser is STOPPED";
  msg[4][1]="  \"  \"\n"+
            " ";
  msg[5][0]="Last transmission of commands: ";
  msg[5][1]="  : ";

  if (Language<0 || Language>1) Message("Language is invalid");
  if (IsExpertEnabled()) Message(msg[0][Language]);
  else Message(msg[1][Language]);
}

//+----------------------------------------------------------------------------+
//|  expert deinitialization function                                          |
//+----------------------------------------------------------------------------+
void deinit() {
  Comment("");
}

//+----------------------------------------------------------------------------+
//|  expert start function                                                     |
//+----------------------------------------------------------------------------+
void start() {
  if (NumberAccount>0 && NumberAccount!=AccountNumber()) {
    Message(msg[2][Language]); return;
  }
  if (IntUpdate<=0) MainBody();
  else {
    while (IsExpertEnabled() && !IsStopped()) {
      if (IsConnected()) {
        MainBody();
        Sleep(1000*IntUpdate);
      } else Comment(msg[3][Language]);
    }
    Message(msg[4][Language]);
  }
}

//+----------------------------------------------------------------------------+
//|                                                        |
//+----------------------------------------------------------------------------+
void MainBody() {
  int    i;
  string st;

  FileDelete(stFileName);
  WritingLineInFile(stFileName, "=begin=");
  st=DoubleToStr(OrdersTotal(), 0)+";"
    +DoubleToStr(AccountBalance(), 2)+";"
    +DoubleToStr(TimeCurrent(), 0)+";"
    +DoubleToStr(OpenDuringTime, 0)
    ;
  WritingLineInFile(stFileName, st);
  for (i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) ExportDeals();
  }
  WritingLineInFile(stFileName, "=end=");

  st=msg[5][Language]+TimeToStr(LocalTime(), TIME_DATE|TIME_SECONDS);
  Comment(st);
}

//+----------------------------------------------------------------------------+
//|                                                               |
//+----------------------------------------------------------------------------+
void ExportDeals() {
  int    dg;
  string st="";

  dg=MarketInfo(OrderSymbol(), MODE_DIGITS);
  if (dg==0) if (StringFind(OrderSymbol(), "JPY")<0) dg=4; else dg=2;

  st=st+DoubleToStr(OrderTicket(), 0)+";";
  st=st+DoubleToStr(OrderOpenTime(), 0)+";";
  st=st+DoubleToStr(OrderType(), 0)+";";
  st=st+DoubleToStr(OrderLots(), 1)+";";
 // st=st+OrderSymbol()+";";
 st=st+StringSubstr(OrderSymbol(),0,8)+";";
  st=st+DoubleToStr(OrderOpenPrice(), dg)+";";
  st=st+DoubleToStr(OrderStopLoss(), dg)+";";
  st=st+DoubleToStr(OrderTakeProfit(), dg)+";";
  st=st+OrderComment();
  WritingLineInFile(stFileName, st);
}

//+----------------------------------------------------------------------------+
//|                                                           |
//+----------------------------------------------------------------------------+
void WritingLineInFile(string FileName, string text) {
  int file_handle=FileOpen(FileName, FILE_READ|FILE_WRITE, " ");

	if (file_handle>0) {
    FileSeek(file_handle, 0, SEEK_END);
    FileWrite(file_handle, text);
    FileClose(file_handle);
  }
}

//+----------------------------------------------------------------------------+
//|                                              |
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0 && PrintEnable) Print(m);
}
//+----------------------------------------------------------------------------+

